/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.Vector;
import java.util.Hashtable;

/**
 *
 * @author user
 */
public class Model {

    public int m;
    public int n;
    public double pn;
    public Hashtable<Args, Vector<Rule>> rules;
    
    public Model (int m0, int n0) {
        m = m0;
        n = n0;
        pn = 0;
        rules = new Hashtable();
        for (Args arg : View.args.argSet)
            rules.put(arg, new Vector());        
    }
    
    public Model (String fileName) {
        try {
            BufferedReader file = new BufferedReader(new FileReader(fileName));
           
            StreamTokenizer parser = new StreamTokenizer(new StringReader(file.readLine()));
            int ttype = parser.nextToken();
            if (ttype == StreamTokenizer.TT_NUMBER)
                m = (int)parser.nval;
            ttype = parser.nextToken();
            ttype = parser.nextToken();
            if (ttype == StreamTokenizer.TT_NUMBER)
                n = (int)parser.nval;
            
            pn = Double.valueOf(file.readLine()).doubleValue();

            rules = new Hashtable();
            for (Args arg : View.args.argSet)
                rules.put(arg, new Vector());        

            for (int i = 1; i <= 46; i++) {
                int left = -2;
                int middle = -2;
                int right = -2;
                Args arg = null;
                
                parser = new StreamTokenizer(new StringReader(file.readLine()));
                ttype = parser.nextToken();
                ttype = parser.nextToken();
                ttype = parser.nextToken();
                if (ttype == StreamTokenizer.TT_NUMBER)
                    left = (int)parser.nval;
                ttype = parser.nextToken();
                ttype = parser.nextToken();                
                if (ttype == StreamTokenizer.TT_NUMBER)
                    middle = (int)parser.nval;
                ttype = parser.nextToken();
                ttype = parser.nextToken();
                if (ttype == StreamTokenizer.TT_NUMBER)
                    right = (int)parser.nval;
                if ((left != -2) && (middle != -2) && (right != -2))
                    arg = View.args.getArg(left, middle, right);

                ttype = parser.nextToken();
                ttype = parser.nextToken();
                ttype = parser.nextToken();
                ttype = parser.nextToken();
                while (ttype == 40) {
                    double p = -1;
                    int s = -1;
                    int crash = -1;
                    int cell = -1;
                    while (ttype != StreamTokenizer.TT_NUMBER)
                        ttype = parser.nextToken();
                    if (ttype == StreamTokenizer.TT_NUMBER)
                        p = parser.nval;
                    ttype = parser.nextToken();
                    ttype = parser.nextToken();
                    if (ttype == StreamTokenizer.TT_NUMBER)
                        s = (int)parser.nval;
                    ttype = parser.nextToken();
                    ttype = parser.nextToken();
                    if (ttype == StreamTokenizer.TT_NUMBER)
                        cell = (int)parser.nval;
                    ttype = parser.nextToken();
                    ttype = parser.nextToken();
                    if (ttype == StreamTokenizer.TT_NUMBER)
                        crash = (int)parser.nval;
                    ttype = parser.nextToken();
                    ttype = parser.nextToken();
                    if (ttype != 41)
                        ttype = parser.nextToken();
                    
                    if ((p != -1) && (s != -1) && (crash != -1) && (cell != -1))
                        rules.get(arg).add(new Rule(p, s, cell, crash, arg));
                }
            }
            
            file.close();           
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void storeToFile(String fileName) {
        try {
            FileWriter file = new FileWriter(fileName);
            file.write(m + " x " + n + "\n");
            file.write(pn + "\n");
            for (Args arg : View.args.argSet) {
                arg.storeToFile(file);
                file.write(" = (");
                Vector<Rule> ruleset = rules.get(arg);
                for (Rule r : ruleset) {
                    r.storeToFile(file);
                    if (r != ruleset.lastElement())
                        file.write(", ");
                }
                file.write(")\n");
            } 
            file.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    
    public Rule getMove(Args arg) {
        double select = Math.random();
        double p = 0;
        Rule result = null;
        for (Rule rule : rules.get(arg)) {
            p += rule.p;
            if ((select < p) && (result == null))
                result = rule;
        }
        return result;
    }
}
