/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.Vector;



/**
 *
 * @author user
 */
public class State {
    
    public int m;
    public int n;
    public int t;
    public int[][] s;
    public Vector<Car> cars;
    public int moved;

    public State (int m0, int n0) {
        t = 0;
        m = m0;
        n = n0;
        moved = 0;
        s = new int[m + 1][n + 1];
        for (int y = 1; y <= m; y++)
            for (int x = 1; x <= n; x++)
                s[y][x] = 0;
    }
    
    
    public State (String fileName) {
        try {
            moved = 0;
            BufferedReader file = new BufferedReader(new FileReader(fileName));
            t = Integer.valueOf(file.readLine()).intValue();
            
            StreamTokenizer parser = new StreamTokenizer(new StringReader(file.readLine()));
            int ttype = parser.nextToken();
            if (ttype == StreamTokenizer.TT_NUMBER)
                m = (int)parser.nval;
            ttype = parser.nextToken();
            ttype = parser.nextToken();
            if (ttype == StreamTokenizer.TT_NUMBER)
                n = (int)parser.nval;

            if ((m >= 1) && (n >= 1))
                s = new int[m + 1][n + 1];
            
            for (int y = 1; y <= m; y++) {
                String line = file.readLine();
                for (int x = 1; x <= n; x++)
                    s[y][x] = Integer.valueOf("" + line.charAt(x - 1)).intValue();
            }
            
            file.close();
        } catch (Exception e) {
            e.printStackTrace();
        }        
    }
    
    
    public void storeToFile(String fileName) {
        try {
            FileWriter file = new FileWriter(fileName);
            file.write(t + "\n");
            file.write(m + " x " + n + "\n");
            for (int y = 1; y <= m; y++) {
                for (int x = 1; x <= n; x++)
                    file.write(Integer.toString(s[y][x]));
                file.write("\n");
            }
            file.close();
        } catch (Exception e) {
            
        }        
    }    
    
    
    public Vector<Car> cars() {
        cars = new Vector();
        for (int x = 1; x <= n; x++)
            for (int y = 1; y <= m; y++)
                if (s[y][x] == 1)
                    cars.add(new Car(y, x));
        return cars;
    }
    
    
    public Car findCar(int y, int x) {
        for (Car car : cars)
            if ((car.x == x) && (car.y == y))
                return car;
        return null;        
    }
    
    public Args getArg(Car car) {
        if (car.x == n)
            return View.args.getArg(-1, -1, -1);
        int left = (car.y - 1 >= 1) ? s[car.y - 1][car.x + 1] : -1;
        int middle = s[car.y][car.x + 1];
        int right = (car.y + 1 <= m) ? s[car.y + 1][car.x + 1] : -1;
        return View.args.getArg(left, middle, right);
    }
    
    public int numOfCars() {
        int result = 0;
        for (int x = 1; x <= n; x++)
            for (int y = 1; y <= m; y++)
                if (s[y][x] == 1) result++;
        return result;
    }
    
    public int numOfBreaks() {
        int result = 0;
        for (int x = 1; x <= n; x++)
            for (int y = 1; y <= m; y++)
                if (s[y][x] == 2) result++;
        return result;
    }
}
